/******************************

Filename: common.h

******************************/

#ifndef _COMMON_H
#define _COMMON_H

/******\********/

/**
  *LED̓_wƏowێ܂B
  */
typedef struct{
	char 	LED_PORTD;
	char 	LED_PORTE;
	char 	LED_PORTB;
	char 	LED_DUTY;	//0~100  %
	char	LED_STATE;
	short	SPK_TGRA;
	short	SPK_TGRB;
    int		SPK_STATE;	//1:ON  0:OFF
} strLedSpeaker;


/******}N`********/
#define TRUE 				0
#define FALSE 				-1
#define SPK_ON  			1
#define SPK_OFF 			0	
#define SW_ON 				0
#define SW_OFF  			1
#define ON 					1
#define OFF 				0
#define CLEAR 				0

#define SAMPLING_NUM 		10 	// SW`^h~
#define SW_NUM 				13	// SW

#define SW_NON_PRESS		0
#define SW_SINGLE_PRESS		1	
#define SW_MULTIPLE_PRESS	2

#define DUTY_HALF			50
#define DUTY_ONE_THIRD		33
#define DUTY_HALF_CNT		5
#define DUTY_ONE_THIRD_CNT	3
#define	DUTY_CNT_MAX		10
#define SOUND_NUM			14
#define	LED_NUM				8

#define SW0					0	//Vb
#define SW1					1	//h
#define SW2					2	//b
#define SW3					3	//
#define SW4					4	//~b
#define SW5					5	//~,
#define SW6					6	//t@
#define SW7					7	//\b
#define SW8					8	//\	
#define SW9					9	//b
#define SW10				10	//
#define SW11				11	//Vb
#define SW12				12	//V
#define SW13				13	//h

#define SI_FLAT				0	//Vb
#define DO					1	//h
#define RE_FLAT				2	//b
#define RE					3	//
#define MI_FLAT				4	//~b
#define MI					5	//~
#define FA					6	//t@
#define SO_FLAT				7	//\b
#define SO					8	//\	
#define RA_FLAT				9	//b
#define RA					10	//
#define SI_FLAT_HIGH		11	//Vb
#define SI					12	//V
#define DO_HIGH				13	//h

#define LED0				0	//LED0
#define LED1				1	//LED1
#define LED2				2	//LED2
#define LED3				3	//LED3
#define LED4				4	//LED4
#define LED5				5	//LED5
#define LED6				6	//LED6
#define LED7				7	//LED7
#define LED8				8	//LED8

#define	SOUND_REST			0xf0//x
#define	SOUND_END			0xff//tI
#define LED_REST			0xf0//
#define MUTE				0xff//E@
#define GATE_TIME			0.98//Q[g^C邽߂̌W
#define NON_OPERATE_TIME 	10000//쎞
#define MANUAL_LED_FLG		0	//LED̃}jAtO
#define AUTO_LED_FLG		1	//LED̎ttO


#ifdef _NeIRO_Main_ 
/***************************************************/

int						g_InitialCheckDone = FALSE;					// CjV`FbN̊tO
int						g_InitialTimerCount = 0;					// CjV`FbN̎ԊǗJE^[
unsigned char			g_sampling_sw[SW_NUM][SAMPLING_NUM] = {0};	// `^Oh~ׂ̈SWێz̏
unsigned short			g_NonOperationCount = 0; 					// 쎞ԃJE^[
unsigned char			g_Cycle1msFlag = OFF;						// 1msǗtO
unsigned char			g_OrderIdx = 0;								// te[ũCNgsׂ̕ϐ
unsigned short 			g_AutoPerformCnt = 0;						// ԊǗϐ
#else
/******O[oϐ****/
extern int				g_InitialCheckDone;	
extern int				g_InitialTimerCount;	
extern unsigned char	g_Cycle1msFlag; 
extern unsigned char	g_sampling_sw[SW_NUM][SAMPLING_NUM];
extern unsigned char	g_OrderIdx;
extern unsigned short	g_NonOperationCount;
extern unsigned short	g_AutoPerformCnt;

/******֐̃vg^Cv錾****/
extern void sampling_sw_data(void);
extern void fix_sampling_data(unsigned char* Sw_Info);
extern void fix_sw_data(unsigned char* Sw_Info,unsigned char* Push_Sw_Num ,unsigned char* Push_Sw_Cnt);
extern void set_mtu(strLedSpeaker* str, unsigned char Push_Sw_Num, unsigned char Spk_State);
extern void Auto_Perform(strLedSpeaker* str1, unsigned char* Push_Sw_Num);
extern void HWS_Ini_Port(void);
extern void HWS_Ini_Clock(void);
extern void HWS_Ini_CMT(void);
extern void HWS_Ini_MTU(void);
extern void init_setting(void);

#endif // _NeIRO_Main_
#endif // !_COMMON_H
