/*****************************

Filename: init_check.c

*****************************/

#include "iodefine.h"
#include "common.h"

/****************************/

/**
  * CjV쏈s܂B
  * ʊ֐@1msecƂɌĂяo邱Ƃ҂܂
  * ʊ֐Ł@strLedSpeaker̒`Kvł
  * ʊ֐Ł@g_InitialCheckDone̒lŕ򂪕Kvł
  * g_InitialTimerCount CjV0ɂĂ
  * g_InitialCheckDone	CjVFALSEɂĂ
  *
  * LEDo͂w肵܂
  * Xs[J[o͂w肷
  * g_InitialTimerCountJEgAbv܂
  * @param strLedSpeaker @@LEDSPEAKER̓w@\
  * @return @@@@@@@@Ȃ
  * @author Yoshinobu Ito
  * @version 1
  */
void initial_check(strLedSpeaker* str)
{
	
	enum InitState {BeforeInit,Yellow,Blue,Purple,White,ExitInit};
	
	static int act_state = BeforeInit;
	
	// ԃ`FbN
	if(g_InitialTimerCount < 500)
	{
		if(act_state == BeforeInit)
		{
			// LEDFF R G
			str->LED_PORTD = 0xDB;
			str->LED_PORTE = 0xB6;
			str->LED_PORTB = 0x6D;
			str->LED_DUTY  = 50;
		
			// SPEAKER :OFF
			str->SPK_STATE = SPK_OFF;
			act_state      = Yellow;
		}
	}
	else if(g_InitialTimerCount < 1000)
	{
		if(act_state == Yellow)
		{
			// LEDFF  G B 
			str->LED_PORTD = 0xB6;
			str->LED_PORTE = 0x6D;
			str->LED_PORTB = 0xDB;
			str->LED_DUTY  = 50;
		
			// SPEAKER : OFF
			str->SPK_STATE = SPK_OFF;
			act_state      = Blue;
		}
	}
	else if(g_InitialTimerCount < 1500)
	{
		if(act_state == Blue)
		{
			// LEDFF  R B
			str->LED_PORTD = 0x6D;
			str->LED_PORTE = 0xDB;
			str->LED_PORTB = 0xB6;
			str->LED_DUTY  = 50;
		
			// SPEAKER :OFF
			str->SPK_STATE = SPK_OFF;
			act_state      = Purple;
		}
	}
	else if(g_InitialTimerCount < 2000)
	{
		if(act_state == Purple)
		{
			// LEDFF R G B 
			str->LED_PORTD = 0xFF;
			str->LED_PORTE = 0xFF;
			str->LED_PORTB = 0xFF;
			str->LED_DUTY  = 33;
		
			// SPEAKER :̉
			str->SPK_TGRA  = 1705;
			str->SPK_TGRB  = 853;
			str->SPK_STATE = SPK_ON;
			act_state      = White;
		}
	}
	else
	{
		if(act_state == White)
		{
			// LEDF
			str->LED_PORTD = 0x00;
			str->LED_PORTE = 0x00;
			str->LED_PORTB = 0x00;
			str->LED_DUTY  = 0;
		
			// SPEAKER : OFF
			str->SPK_STATE  = SPK_OFF;

			g_InitialCheckDone = TRUE;		//ׂẴCjV`FbN
			act_state          = ExitInit;
		}
	}
	
	g_InitialTimerCount++;
				
    return ;
}