/******************************

Filename: input_sw_data.c

******************************/

#include "iodefine.h"
#include "common.h"

/***************************************************/

/**
  * SW擾ALEDo͂wƃXs[J[o͂w肵܂B
  * ʊ֐@1msecƂɌĂяo邱Ƃ҂܂
  * ʊ֐Ł@strLedSpeaker̒`Kvł
  * 
  * @param 	strLedSpeaker* str	LEDSPEAKER̓w@\
  * @return @@@@@@@@Ȃ
  * @author Keijiro Ichikawa
  * @version 1
  */
void input_sw_data(strLedSpeaker* str, unsigned char* Push_Sw_Num)
{		
	unsigned char sw_info[SW_NUM] 	= {0,0,0,0,0,0,0,0,0,0,0,0,0};	// SWm
	unsigned char push_sw_cnt = 0;									// XCb`	
	
	//****************************************
	// SW1-13̏TvO					
	//****************************************
	sampling_sw_data();

	//****************************************
	// TvOm	
	//****************************************
	fix_sampling_data(&sw_info[0]);

	//****************************************
	// SWm	
	//****************************************
	fix_sw_data(&sw_info[0], Push_Sw_Num, &push_sw_cnt);

	// SW̌u0vȊOł邩H
	if(SW_NON_PRESS != push_sw_cnt)
	{
		// SW1ĂH	
		if(SW_SINGLE_PRESS == push_sw_cnt)
		{
			str->LED_STATE = MANUAL_LED_FLG;						// LED[h}jAɂ

			//*********************************
			// LED_w
			//*********************************
			set_led(str, *Push_Sw_Num);		

			//*********************************
			// ow
			//*********************************
			set_mtu(str, *Push_Sw_Num, SPK_ON);
		}
		// SW2ȏ㉟ĂH
		else if(SW_MULTIPLE_PRESS <= push_sw_cnt)
		{
			//*********************************
			// w	
			//*********************************
			set_led(str, MUTE);

			//*********************************
			// w
			//*********************************
			set_mtu(str, *Push_Sw_Num, SPK_OFF);
		}
		g_NonOperationCount = CLEAR;								// 쎞ԂZbg
		g_OrderIdx = CLEAR;											// t̏Ԃ̒lNA
		g_AutoPerformCnt = CLEAR;									// ԊǗϐ
	}	
	// SWĂȂΏE		
	else
	{			
		//*********************************
		// w	
		//*********************************
		set_led(str, MUTE);	
		
		//*********************************
		// w
		//*********************************
		set_mtu(str, *Push_Sw_Num, SPK_OFF);
			
		g_NonOperationCount++;										// 쎞ԂCNg
	}
	push_sw_cnt = CLEAR;
}
/**
  * SWTvO܂B
  * ʊ֐@1msecƂɌĂяo邱Ƃ҂܂
  * g_sampling_sw[SW_NUM][SAMPLING_NUM]SW̃TvOi[Ă܂
  * @param 					Ȃ
  * @return @@@@@@@@Ȃ
  * @author Keijiro Ichikawa
  * @version 1
  */
void sampling_sw_data(void)
{
	
 	static unsigned char sampling_cnt	= 0;						// 10TvOJEg	
	unsigned char sw_data_temp 			= PORTC.PORT.BYTE; 			// SW1-8̏擾
	unsigned short sw_data				= PORT5.PORT.BYTE;			// SW9-13̏擾iPORT5̏3bit͕sgpj
	unsigned char i = 0;

	sw_data = (sw_data << 8) | sw_data_temp;						// SW1-13̏ێ 
	
	// SW1-13̏̃TvO
	for( i = 0; i < SW_NUM; i++)
	{						 		
		// iԖڂSWĂHiiԖڂbit0H)
		if( (SW_ON == (sw_data & (1 << i))))
		{
			g_sampling_sw[i][sampling_cnt] = ON;					// SW_ONzɕێ
		}
		else
		{
			g_sampling_sw[i][sampling_cnt] = OFF;					// SW_OFFzɕێ
		}
	} 
	
	sampling_cnt++;													// TvOJEgCNg
	
	// 10TvOς݁H
	if(SAMPLING_NUM <= sampling_cnt)	
	{
		sampling_cnt = CLEAR;										// TvOJEgNA
	}
	
}
/**
  * TvOSWm肵܂B
  * ʊ֐@1msecƂɌĂяo邱Ƃ҂܂
  * Sw_Info[SW_NUM]Ɋm肵SWzɊi[܂
  * @param 	Sw_Info[SW_NUM]	[out]m肵SW̔zԂ܂
  * @return @@@@@@@@Ȃ
  * @author Keijiro Ichikawa
  * @version 1
  */
void fix_sampling_data(unsigned char* Sw_Info)
{
	unsigned char i = 0;	
	
	// TvOSW1-13̏m肷
	for(i = 0; i < SW_NUM; i++)	
	{
		unsigned char on_cnt = 0;									// TvOONł邱ƂJEg	
		unsigned char s = 0;
		
		// 10TvOmF
		for(s = 0; s < SAMPLING_NUM; s++)	
		{
			// iԖڂSWsڂ̃TvOɉSW?
			if(ON == g_sampling_sw[i][s]) 
			{
				on_cnt++;
			}	
		}	
		if(SAMPLING_NUM == on_cnt)									// iԖڂSW̃TvOf[^10ONH
		{
			Sw_Info[i] = ON;										// SWƋL^
		}  
		else if(OFF == on_cnt)//@@@
		{
			Sw_Info[i] = OFF;										// SWĂȂƋL^
		}
 	}
}
/**
  * CjV쏈s܂B
  * ʊ֐@1msecƂɌĂяo邱Ƃ҂܂
  * @param 	Sw_Info[SW_NUM]	m肵SW̔z
  * @param 	*Push_Sw_Num	[out]SW̔ԍԂ܂
  * @param 	*Push_Sw_Cnt	[out]SW̐Ԃ܂
  * @return @@@@@@@@Ȃ
  * @author Keijiro Ichikawa
  * @version 1
  */
void fix_sw_data(unsigned char *Sw_Info, unsigned char *Push_Sw_Num, unsigned char *Push_Sw_Cnt)
{	
	unsigned char i = 0;
	
	// SW1-13̉E񉟉܂Ƃ߂
	for(i = 0; i < SW_NUM; i++)
	{	
		// iԖڂSW͉ĂH
		if( ON == Sw_Info[i])	
		{
			*Push_Sw_Num = i+1; 				// iԖڂSWĂ邱ƂL^i͉SW1̃f[^ȊOsKvׁ̈A1L^j
			(*Push_Sw_Cnt)++;					// SWꂽJEg
		}			
	}		
}